require "defines"

local onbuild = function (event) 
	game.players[1].print(event.createdentity.position.x .. " " .. event.createdentity.position.y)
	if event.createdentity.name == "filtered-chest-proxy" then
		markForDestruction(event.createdentity)
		buildNewFilteredChest(event.createdentity.position)
	end
end

local onpremine = function (event)
	if event.entity.name == "filtered-chest" or event.entity.name == "filtered-rail" or event.entity.name == "filtered-chest-proxy" then
		destoryFilteredChest(event.entity.position)
	end
end

local goNextTick = function(event)
	if glob.destroyList ~= nil then
		for i, entity in ipairs(glob.destroyList) do
			if entity ~= nil and entity.valid then
				entity.destroy()
			end
		end
		glob.destroyList = nil
	end
	-- if glob.createList ~= nil then
		-- for i, args in ipairs(glob.createList) do
			-- newposition = game.findnoncollidingposition(args.name,args.position,1,0.5)
			-- game.players[1].print(newposition.x .. " " .. newposition.y)
			-- game.createentity{name=args.name, position = newposition, direction=0}
		-- end
		-- glob.createList = nil
	-- end
	game.onevent(defines.events.ontick, nil)
end

game.onevent(defines.events.onbuiltentity, onbuild)
game.onevent(defines.events.onpreplayermineditem, onpremine)

function markForDestruction(entity)
	if glob.destroyList == nil then
		glob.destroyList = {}
	end
	
	table.insert(glob.destroyList,entity)
	game.onevent(defines.events.ontick, goNextTick)
end

function destoryFilteredChest(position)
	if position ~= nil then
		entities = game.findentities({position,position})
		for i, entity in ipairs(entities) do
			if entity.valid and (entity.name == "filtered-rail" or entity.name == "filtered-chest") then
				markForDestruction(entity)
			end
		end
	end
end

function buildNewFilteredChest(position)
	game.players[1].print(position.x .. " " .. position.y)
	game.createentity{name="filtered-rail", position = position, direction = 0,force=game.forces.player}
	--game.createentity{name="filtered-chest", position = position, direction = 0}
	game.createentity{name="filtered-chest", position = position, force=game.forces.player}
end
	-- if glob.createList == nil then
		-- glob.createList = {}
	-- end
	-- table.insert(glob.createList,{name="filtered-chest",position=position})
	-- game.onevent(defines.events.ontick, goNextTick)