
local function filteredrailpics(elems)
  local keys = {{"straight_rail", "horizontal", 64, 64},
                {"straight_rail", "vertical", 64, 64},
				{"straight_rail", "diagonal", 64, 64},
                {"curved_rail", "vertical", 64, 64},
                {"curved_rail" ,"horizontal", 64, 64}}
  local res = {}
  for _ , key in ipairs(keys) do
    part = {}
    dashkey = key[1]:gsub("_", "-")
    for _ , elem in ipairs(elems) do
      part[elem[1]] = {
        filename = "__FilteredChest__/graphics/trans64.png",
        priority = "extra-high",
        width = key[3],
        height = key[4]
      }
    end
    res[key[1] .. "_" .. key[2]] = part
  end
  res["rail_endings"] = {
    sheet =
    {
      filename = "__FilteredChest__/graphics/trans64.png",
      priority = "high",
      width = 64,
      height = 64
    }
  }
  return res
end



data:extend(
{

  {
    type = "rail-category",
    name = "filtered"
  },

  {
    type = "cargo-wagon",
    name = "filtered-chest",
		icon = "__FilteredChest__/graphics/filtered-chest-icon.png",
    flags = {"placeable-neutral", "player-creation", "placeable-off-grid"},
    inventory_size = 40,
    minable = {mining_time = 1, result = "filtered-chest-proxy"},
    max_health = 40,
    corpse = "medium-remnants",
    collision_box = {{-1, -1}, {1, 1}},
    selection_box = {{-1, -1}, {1, 1}},
    weight = 1000,
    max_speed = 1,
    braking_force = 3,
    friction_force = 1,
    air_resistance = 1,
    connection_distance = 3.3,
    joint_distance = 1.2,
    energy_per_hit_point = 5,
    pictures =
    {
      priority = "very-low",
      width = 32,
      height = 32,
      axially_symmetrical = true,
      back_equals_front = true,
      direction_count = 1,
      filenames =
      {
        "__FilteredChest__/graphics/filtered-chest.png"
      },
      line_length = 1,
      lines_per_file = 1
    },
    rail_category = "filtered",
	
	order = "z",
  },
  
  {
    type = "container",
    name = "filtered-chest-proxy",
    icon = "__FilteredChest__/graphics/filtered-chest-icon.png",
    flags = {"placeable-neutral", "player-creation"},
    minable = {mining_time = 1, result = "filtered-chest-proxy"},
    max_health = 50,
    corpse = "small-remnants",
    collision_box = {{-1, -1}, {1, 1}},
    fast_replaceable_group = "container",
    selection_box = {{-1, -1}, {1, 1}},
    inventory_size = 1,
    picture =
    {
      filename = "__FilteredChest__/graphics/filtered-chest-icon.png",
      priority = "extra-high",
      width = 46,
      height = 33,
      shift = {0.3, 0}
    }
  },
  
{
    type = "rail",
    name = "filtered-rail",
    icon = "__FilteredChest__/graphics/filtered-chest-icon.png",
    flags = {"placeable-neutral", "player-creation", "placeable-off-grid"},
    max_health = 100,
    corpse = "small-remnants",
	collision_box = {{-0.9, -0.9}, {0.9, 0.9}},
    selection_box = {{-0.9, -0.9}, {0.9, 0.9}},
    bending_type = "straight",
    rail_category = "filtered",
    pictures = filteredrailpics({{"metals", "metals"}, {"backplates", "backplates"}, {"ties", "ties"}, {"stone_path", "stone-path"}}),
	order = "z",
  },
  
})

-- string.format("__Wagons__/resources/%s/%s-%s-%s.png", dashkey, dashkey, key[2], elem[2])